org.springframework.data.repository.config

## Interface RepositoryConfiguration<T extends RepositoryConfigurationSource>

All Known Implementing Classes:
  DefaultRepositoryConfiguration

    public interface RepositoryConfiguration<T extends RepositoryConfigurationSource>

Configuration information for a single repository instance.

Author:
  Oliver Gierke, Mark Paluch

### Method Summary

All Methods Instance Methods Abstract Methods
`Streamable<String>` `getBasePackages()` Returns the base packages that the repository was scanned under.
`T` `getConfigurationSource()` Returns the `RepositoryConfigurationSource` that backs the `RepositoryConfiguration`.
`Streamable<TypeFilter>` `getExcludeFilters()` Returns the `TypeFilter`s to be used to exclude packages from repository scanning.
`Streamable<String>` `getImplementationBasePackages()` Returns the base packages to scan for repository implementations.
`Optional<String>` `getNamedQueriesLocation()` Returns the location of the file containing Spring Data named queries.
`Object` `getQueryLookupStrategyKey()` Returns the key to resolve a `QueryLookupStrategy` from eventually.
`Optional<String>` `getRepositoryBaseClassName()` Returns the name of the repository base class to be used or null if the store specific defaults shall be applied.
`String` `getRepositoryFactoryBeanClassName()` Returns the name of the repository factory bean class to be used.
`String` `getRepositoryInterface()` Returns the interface name of the repository.
`String` `getResourceDescription()` Returns a human readable description of the repository interface declaration for error reporting purposes.
`Object` `getSource()` Returns the source of the `RepositoryConfiguration`.
`boolean` `isLazyInit()` Returns whether to initialize the repository proxy lazily.
`boolean` `isPrimary()` Returns whether the repository is the primary one for its type.
`ImplementationDetectionConfiguration` `toImplementationDetectionConfiguration(MetadataReaderFactory factory)` Returns the `ImplementationDetectionConfiguration` to be used for this repository.
`ImplementationLookupConfiguration` `toLookupConfiguration(MetadataReaderFactory factory)` Returns the `ImplementationLookupConfiguration` for the given `MetadataReaderFactory`.

### Method Detail

#### getBasePackages

    Streamable<String> getBasePackages()

Returns the base packages that the repository was scanned under.

Returns:

#### getImplementationBasePackages

    Streamable<String> getImplementationBasePackages()

Returns the base packages to scan for repository implementations.

Returns:
Since:
  2.0

#### getRepositoryInterface

    String getRepositoryInterface()

Returns the interface name of the repository.

Returns:

#### getQueryLookupStrategyKey

    Object getQueryLookupStrategyKey()

Returns the key to resolve a `QueryLookupStrategy` from eventually.

Returns:
See Also:
  `QueryLookupStrategy.Key`

#### getNamedQueriesLocation

    Optional<String> getNamedQueriesLocation()

Returns the location of the file containing Spring Data named queries.

Returns:

#### getRepositoryBaseClassName

    Optional<String> getRepositoryBaseClassName()

Returns the name of the repository base class to be used or null if the store specific defaults shall be applied.

Returns:
Since:
  1.11

#### getRepositoryFactoryBeanClassName

    String getRepositoryFactoryBeanClassName()

Returns the name of the repository factory bean class to be used.

Returns:

#### getSource

    @Nullable
    Object getSource()

Returns the source of the `RepositoryConfiguration`.

Returns:

#### getConfigurationSource

    T getConfigurationSource()

Returns the `RepositoryConfigurationSource` that backs the `RepositoryConfiguration`.

Returns:

#### isLazyInit

    boolean isLazyInit()

Returns whether to initialize the repository proxy lazily.

Returns:

#### isPrimary

    boolean isPrimary()

Returns whether the repository is the primary one for its type.

Returns:
  true whether the repository is the primary one for its type.
Since:
  2.3

#### getExcludeFilters

    Streamable<TypeFilter> getExcludeFilters()

Returns the `TypeFilter`s to be used to exclude packages from repository scanning.

Returns:

#### toImplementationDetectionConfiguration

    ImplementationDetectionConfiguration toImplementationDetectionConfiguration(MetadataReaderFactory factory)

Returns the `ImplementationDetectionConfiguration` to be used for this repository.

Parameters:
  `factory` - must not be null.
Returns:
  will never be null.
Since:
  2.1

#### toLookupConfiguration

    ImplementationLookupConfiguration toLookupConfiguration(MetadataReaderFactory factory)

Returns the `ImplementationLookupConfiguration` for the given `MetadataReaderFactory`.

Parameters:
  `factory` - must not be null.
Returns:
  will never be null.
Since:
  2.1

#### getResourceDescription

    @Nullable
    String getResourceDescription()

Returns a human readable description of the repository interface declaration for error reporting purposes.

Returns:
  can be null.
Since:
  2.3